#include <stdio.h>
#include <reg52.h>

unsigned char C6,D, C, z;
unsigned int D1, D2, C1, C2, C3, C4, C5, W1, W2, W3, W4;
float TEMP;
float TLAK;
unsigned char buf[6];

sbit MCLK = P1 ^ 0;				// master clk at pin P1.0 - 32768Hz
sbit SCLK = P1 ^ 3;
sbit DIN = P1 ^ 1;
sbit DOUT = P1 ^ 2;

#define StartB 1					// start a stop bity
#define StopB 0
#define D1_com 5	//D1 se vysila jako 1010
#define D2_com 9	//D2 se vysila jako 1001
#define Word1 0x2A 		// kalibracni slova z cidla
#define Word2 0x1A
#define Word3 0x26
#define Word4 0x16

void Sclk_pulse(void)				// SCLK pulse
{
	SCLK = 1;
	_nop_();
	SCLK = 0;
	_nop_();
}

void Start_stop_bits(unsigned char Selection)			// sends 3 start bits or stop bits
{
unsigned char n;

	for (n = 0; n <3; n++)			//first 3 start bits
	{
		if (Selection == StartB) DIN = 1;
		else DIN = 0;
		Sclk_pulse();
	}
}


unsigned int Read_Data(void)					//precte 2 bajty odpovedi z cidla
{
unsigned char o;
unsigned int Vystup = 0;

	for (o = 0; o < 16; o++)
	{
		SCLK = 1;
		_nop_();
		SCLK = 0;
		if (DOUT == 1) Vystup++;			// pricte 1cku
		if (o != 15) Vystup = (Vystup * 2);
	}
	Sclk_pulse();	//chce to 17. puls
	return (Vystup);

}

unsigned int SensorData (unsigned char What)
{
unsigned char m;
unsigned int Pomocna;

	SCLK = 0;
	DOUT = 1; 		//input
	DIN = 0;
	C = What;

	Start_stop_bits(StartB);
	for (m = 0; m < 4; m++)
	{
		D = (C & 0x01);
		if ((D == 1)) DIN = 1;
		else DIN = 0;
		Sclk_pulse();
		C = C/2;					// nachystat dalsi bit
	}	
	Start_stop_bits(StopB);				//3 nulove stopbity
	Sclk_pulse();							// chce to jeste 2 clocky navic
	Sclk_pulse();

	while(DOUT);						// ceka nez skonci prevod - nez DOUT padne dolu
	
	Pomocna = Read_Data();				// precte 2 bajty dat
	
	return(Pomocna);


}

unsigned int SensorWord (char WhatWord)
//unsigned int SensorWord ()
{
unsigned char p;
unsigned int Pomocna2;

	C = WhatWord;
	SCLK = 0;
	DOUT = 1; 		//input
	DIN = 0;

	Start_stop_bits(StartB);
	for (p = 0; p < 6; p++)
	{
		D = (C & 0x01);
		if ((D == 1)) DIN = 1;
		else DIN = 0;
		Sclk_pulse();
		C = C/2;					// nachystat dalsi bit
	}	
	Start_stop_bits(StopB);				//3 nulove stopbity
	Sclk_pulse();							// chce to jeste 1 clock navic

	while(DOUT == 0);					//pokud se nahodou cidlo neozvalo
	
	Pomocna2 = Read_Data();				// precte 2 bajty dat
	
	return(Pomocna2);
}

void ResetCidla(void)			//udela reset cidla
{
unsigned char q;

	DIN = 0;
	for (q = 0; q < 16; q++)
	{
		DIN = (~DIN);
		Sclk_pulse();
	}	
	for (q = 0; q < 5; q++)			//poslednich 5 clk je DIN = 0
	{
		Sclk_pulse();
	}	

}

/*-------------------------------------------------------------------------------
Prevede char na znaky a posle seriovkou
---------------------------------------------------------------------------------*/
void Prevod_char(long int Hodnota, unsigned char Kolik) {
char a, Zbytek;

	for (a = Kolik; a >= 0; a--) {				// prepocitej do ascii
		Zbytek = Hodnota % 10;
		Hodnota = (Hodnota/10);
		buf [a] = Zbytek + 48;				//  ASCII shift
	}



//ted posli po RS pryc

	for (a = 0; a <= Kolik; a++)
	{
		TI = 0;
		SBUF = buf[a];
		while (TI == 0) {;}		// wait for sending
		TI = 0;
	}

	SBUF = ';';						// oddeleni cisel
	while (TI == 0) {;}	
	TI = 0;

//	LED = !LED;						// blikani ledkou
}

void CalculateCoeficients (void)				// prepocita Cx koeficienty z w1-w4
{

	C2 = (W4 & 0x3F) + ((W3 & 0x3F) << 6);
	C6 = (W2 & 0x3F);
	C5 = (W2 >> 6) + ((W1 &0x01) << 10);
	C1 = (W1 >> 1);
	C3 = (W4 >> 6);
	C4 = (W3 >> 6);

}

void CalculateValues(void)								// vypocita tlak a teplotu
{
unsigned int UT1, dT;
float OFF, SENS, X;

	UT1 = 8*C5 + 20224;

	if (D2 > UT1)											//presny vypocet teploty
	{
		dT = D2 - UT1;
		TEMP = 200 + (float)dT * (C6 + 50)/1024;
	}
	else
	{
		dT = (D2 - UT1) - ((D2 - UT1)/128)*((D2 - UT1)/128)/4;
		TEMP = (200 + (float)dT*(C6+50)/1024 + (float)dT/256);
	}

	OFF = C2*4 + ((C4 - 512)*(float)dT)/4096;
	SENS = C1 + (C3 * (float)dT)/1024 + 24576;
	X = (SENS * ((float)D1 - 7168))/16384 - OFF;
	TLAK = X*100/32 + 250*100;

}
void main (void)
{
long int Suma;


	C_T2 = 0;			// nastaveni 32kHz signalu pomoci tim2
	T2MOD = 3;			
	TR2 = 1;
   RCAP2H = 0xFF;		// 4.19MHz predvolba na 32k
   RCAP2L = 0xE0;

	SCON = 0x40;	
	TMOD = 0x21;							// timer 0 in 16bits mode, tim 1 in 8bits with automatic reload
	TH1 = 0xEE; TL1 = 0xEE;				// transfer speed 600Bd
   TI = 0; 
   TR1 = 1;
	PCON = 0x80;								//1200	

	printf("W1 %u", W1);

	SBUF = 65;
	while (TI == 0) {;}		// wait for sending
	TI = 0;



	W1 = 50426;
	W2 = 9504;
	W3 = 48029;
	W4 = 55028;
	D1 = 17000;
	D2 = 22500;

	ResetCidla();
	W1 = SensorWord (Word1);
	W2 = SensorWord (Word2);
	W3 = SensorWord (Word3);
	W4 = SensorWord (Word4);
	D1 = SensorData (D1_com);	
	D2 = SensorData (D2_com);

	 	TI = 0;	
	while(1)
	{
	Suma = 0;
/*
   	for (z = 0; z < 4; z++)
   	{
	   	D1 = SensorData (D1_com);
	   	Suma = Suma + D1;
   	}
		D1 = Suma/4;
*/	
	z++;
	D1 = SensorData (D1_com);					// teplotu merim jen obcas
	if (z == 28)
	{
		D2 = SensorData (D2_com);
		z = 0;
	}
	
	CalculateCoeficients();
	CalculateValues();

	Prevod_char(TLAK, 4);
	Prevod_char(TEMP, 4);

		SBUF = 13;
		while (TI == 0) {;}		// wait for sending
		TI = 0;

	}
	
}                        











